// hello.cc
#include <node.h>
#include <windows.h>
#include <stdio.h>
#include <sstream>
#include <string>
#include <iostream>


typedef int (__cdecl *MYPROC)();
// typedef int (__stdcall *f_funci)();
// typedef double (*importFunction)(double, double);
typedef long (*importFunction)();


namespace bass {

using v8::FunctionCallbackInfo;
using v8::Isolate;
using v8::Local;
using v8::Object;
using v8::String;
using v8::Value;
HINSTANCE hinstLib;
MYPROC ProcAdd;
// BOOL fFreeResult, fRunTimeLinkSuccess = FALSE;


void Bass_LoadLibrary(const FunctionCallbackInfo<Value>& args) {
  BOOL fRunTimeLinkSuccess = FALSE;
  Isolate* isolate = args.GetIsolate();
  const std::string bassDLL(*(String::Utf8Value(args[0]->ToString())));
  //  Get a handle to the DLL module.
  hinstLib = LoadLibrary(bassDLL.c_str());
  if (hinstLib != NULL)
    fRunTimeLinkSuccess = TRUE;
  args.GetReturnValue().Set(fRunTimeLinkSuccess);
}

void BASS_GetVersion(const FunctionCallbackInfo<Value>& args) {
  std::string fResult = "";
  Isolate* isolate = args.GetIsolate();
  if (!hinstLib) {
    fResult = "Failed to call function, check if bass Library has been loaded properly.";
    args.GetReturnValue().Set(String::NewFromUtf8(isolate, fResult.c_str()));
    return;
  }

  fResult = "Invalid or empty or null";
  importFunction BASS_GetVersion = (importFunction)GetProcAddress(hinstLib, "BASS_GetVersion");
  // If the function address is valid, call the function.
  if (NULL != BASS_GetVersion)
  {
    long v = BASS_GetVersion();
    std::string sVer = std::to_string(v);
    if (v)
      fResult = sVer;
  }
  args.GetReturnValue().Set(String::NewFromUtf8(isolate, fResult.c_str()));
}

// void BASS_GetVersion(const FunctionCallbackInfo<Value>& args) {
//
//
//   LPCTSTR myDLL = "H:\\TK/baseaudioa/examples/libbass/win32-x64/bass.dll";
//   HINSTANCE hinstLib;
//     MYPROC ProcAdd;
//     BOOL fFreeResult, fRunTimeLinkSuccess = FALSE;
//     Isolate* isolate = args.GetIsolate();
//
//     // Get a handle to the DLL module.
//     hinstLib = LoadLibrary(myDLL);
//
// // If the handle is valid, try to get the function address.
//
//   if (hinstLib != NULL)
//   {
//       // ProcAdd = (MYPROC) GetProcAddress(hinstLib, "BASS_GetVersion");
//       importFunction BASS_GetVersion = (importFunction)GetProcAddress(hinstLib, "BASS_GetVersion");
//       // If the function address is valid, call the function.
//
//       if (NULL != BASS_GetVersion)
//       {
//           fRunTimeLinkSuccess = TRUE;
//           // DWORD st= BASS_GetVersion();
//           long s = BASS_GetVersion();
//
//           std::string sText = std::to_string(s);
//           // snprintf(buffer,20,"%d",thatValue);
//   // MessageBox (NULL, (LPCTSTR)s , NULL, NULL);
//           // LPCTSTR ss=LPCTSTR(st);
//           // (ProcAdd) (L"Message sent to the DLL function\n");
//           if (s)
//             args.GetReturnValue().Set(String::NewFromUtf8(isolate, sText.c_str()));
//           else
//             args.GetReturnValue().Set(String::NewFromUtf8(isolate, "ssf"));
//       }
//       // Free the DLL module.
//
//       fFreeResult = FreeLibrary(hinstLib);
//   }
//
//   // If unable to call the DLL function, use an alternative.
//   if (! fRunTimeLinkSuccess)
//       args.GetReturnValue().Set(String::NewFromUtf8(isolate, "not loaded"));
//   // Isolate* isolate = args.GetIsolate();
//   // args.GetReturnValue().Set(String::NewFromUtf8(isolate, "world"));
// }

void init(Local<Object> exports) {
  NODE_SET_METHOD(exports, "Bass_LoadLibrary", Bass_LoadLibrary);
  NODE_SET_METHOD(exports, "BASS_GetVersion", BASS_GetVersion);
}

NODE_MODULE(NODE_GYP_MODULE_NAME, init)

}  // namespace demo
