var chalk = require("chalk");
// var applyShim = require("./shim.js");
// try {
//   applyShim();
// } catch(err) {
//   console.error(chalk.bgRed.white.bold(err));
// }
const addon = require('./build/Release/addon');

var path = require('path');
// var Struct = require('ref-struct');
// var ref = require('ref');
// var ffi = require('ffi');
function Bass(options) {
    // this.ref = ref;
    // this.ffi = ffi;

    options = options || {};
    // basePath must be a valid *absolute* path
    options.basePath = options.basePath || process.cwd();

    // var bass = ref.types.void;
    // var dword = ref.refType(bass);
    // var hwnd = ref.refType(bass);


    var basslibName = '';
    var bassmixlibName = '';
    var bassenclibName = '';
    if (process.platform == 'win32') {
        basslibName = 'bass.dll';
        bassmixlibName = 'bassmix.dll';
        bassenclibName = 'bassenc.dll';
    }
    else if (process.platform == 'darwin') {
        basslibName = 'libbass.dylib';
        bassmixlibName = 'libbassmix.dylib';
        bassenclibName = 'libbassenc.dylib';
    }
    else if (process.platform == 'linux') {
        basslibName = 'libbass.so';
        bassmixlibName = 'libbassmix.so';
        bassenclibName = 'libbassenc.so';
    }
    basslibName = path.join(options.basePath, basslibName);
    bassmixlibName = path.join(options.basePath, bassmixlibName);
    bassenclibName = path.join(options.basePath, bassenclibName);
    this.bassenclibName = bassenclibName;
    this.bassmixlibName = bassmixlibName;

    console.log(chalk.bgBlack.white.bold("Bass library to load is: " + basslibName));

    try {

      if (addon.Bass_LoadLibrary(basslibName))
        console.log(chalk.bgGreen.white.bold("Bass library loaded successfully."));
      else
        console.log(chalk.bgRed.white.bold("Bass library loaded failed."));

    } catch (err) {
      console.log(chalk.bgRed.white.bold("Bass library loading exception." + err));
    }
}

Bass.prototype.BASS_GetVersion = function () {
    return addon.BASS_GetVersion()//.toString(16)
}

exports = module.exports = Bass;
